/* Adott egy n egész számból álló, növekvõ sorrendbe rendezett sorozat: x[1] < x[2] <...< x[n]. 
Állapítsuk meg egy adott szám helyét a sorozatban! Ha az illetõ szám nem található meg a 
sorozatban, írjunk ki egy megfelelõ üzenetet!
*/

#include <iostream>

using namespace std;

void kiir(int n, int x[]){

	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int binarisKereses(int bal, int jobb, int n, int x[], int keresett){
	
	int kozep;
	if(bal > jobb)
		return -1;
	else{
		kozep = ((bal + jobb) / 2);	
		if(keresett < x[kozep])
			return binarisKereses(bal, kozep - 1, n, x, keresett);
		else{	
			if(keresett > x[kozep])
				return binarisKereses(kozep + 1, jobb, n, x, keresett);
			else
				return kozep;
		}
	}
}

int main(){
	int x[] = {0, 1, 4, 6, 8, 12, 34, 56, 78, 102, 123};// a 0 indexű elemet figyelmen kívül hagyjuk

	int n = 10;
	kiir(n, x);
		
	int keresett;
	cout << "keresett = "; cin >> keresett;
	
	int er = binarisKereses(1, n, n, x, keresett);	
	if(er != -1)
		cout << "A keresett szam a " << er << ". indexen talalhato." << endl;
	else
		cout << "A keresett szam nincs a sorozatban!" << endl;
}
